package com.docus.server.common.service;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.IService;
import com.docus.server.common.service.impl.Sort;

import java.util.Collection;
import java.util.List;

public interface IBaseService<T> extends IService<T> {

    T findById(String id);

    List<T> findByIds(Collection<String> ids);

    List<T> findBy(String propertyName, Object propertyValue);

    List<T> findByList(String propertyName, Collection<?> propertyValue);

    List<T> findActiveBy(String propertyName, Object propertyValue);

    List<T> findBy(String propertyName, Object propertyValue, Sort sort);

    List<T> findActiveBy(String propertyName, Object propertyValue, Sort sort);

    T findOneBy(String propertyName, Object propertyValue);

    T findOneByList(String propertyName, Collection<?> propertyValue);

    T findActiveOneBy(String propertyName, Object propertyValue);

    List<T> find(LambdaQueryWrapper<T> queryWrapper);

    T findOne(LambdaQueryWrapper<T> queryWrapper);

    List<T> findAll();

    List<T> findAllActive();

    List<T> findAll(Sort sort);

    List<T> findAllActive(Sort sort);

    int deleteByIdList(List<String> idList);
}
